#ifndef __SLIDETRANSFORM_H__
#define __SLIDETRANSFORM_H__

#include "slideprimitive.h"

//////////////////////////////////////////////////////////////////////
// CSLIDETransform Class
//

class CSLIDETransform : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDETransform();
  virtual ~CSLIDETransform();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline const Matrix &GetMatrix();
  inline const Matrix &GetInverse();
//  inline VOID SetMatrix(const Matrix &m);

//////////////////////////////////////////////////
// Class Variables
//
public:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  Matrix m_m;
  Matrix m_mInverse;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline const Matrix &CSLIDETransform::GetMatrix()
{
  return m_m;
}

inline const Matrix &CSLIDETransform::GetInverse()
{
  return m_mInverse;
}
/*
inline VOID CSLIDETransform::SetMatrix(const Matrix &m)
{
  m_m = m;
}
*/
#endif // __SLIDETRANSFORM_H__


